# args validation
function args_invalid() {
    echo "usage: " $0 "[<options>] explore <classpath_dir> <test_class> [<program_args>]"
    echo "example: " $0 "explore bin edu.illinois.reex.test.JavaUtilConcurrentTests"
    exit 1
}

if [ $# -lt 2 ]; then
    args_invalid
fi

REEX_LIBS=reex-bin

OPTIONS=""
PARAMS=""
EXPLORE=0
for i in $(seq 1 $#)
do
 eval OPT=\${$i}
 if [ "${OPT}" == "explore" ]
 then
   EXPLORE=1
   break
 fi
 OPTIONS="${OPTIONS} ${OPT}"
done

if [ ${EXPLORE} -ne 1 ]; then
    args_invalid
fi

i=$((${i}+1))
eval CLASS_LOC=\${$i}
i=$((${i}+1))
eval CLASS_NAME=\${$i}
i=$((${i}+1))

for k in $(seq ${i} $#)
do
 eval ARG=\${$k}
 PARAMS="${PARAMS} ${ARG}"
done

java -ea -javaagent:${REEX_LIBS}/instrumentor.jar ${OPTIONS} -cp ${REEX_LIBS}/instrumentor.jar:${REEX_LIBS}/explorer.jar:${REEX_LIBS}/junit.jar:${REEX_LIBS}/org.hamcrest.core.jar:${CLASS_LOC} org.junit.runner.JUnitCore ${CLASS_NAME} ${PARAMS}
