package edu.illinois.reex.test;

import junit.framework.Assert;

import org.junit.Test;
import org.junit.runner.RunWith;

import edu.illinois.reex.exploration.JUnit4ReExRunner;

@RunWith(JUnit4ReExRunner.class)
public class Deadlock {

    private int field;
    private Object mutex1 = new Object();
    private Object mutex2 = new Object();

    public void increment1() {
        synchronized (mutex1) {
            synchronized (mutex2) {
                this.field++;
            }
        }
    }

    public void increment2() {
        synchronized (mutex2) {
            synchronized (mutex1) {
                this.field++;
            }
        }
    }

    public int getField() {
        return this.field;
    }

    @Test
    public void test() throws InterruptedException {

        final Deadlock counter = new Deadlock();

        Thread t1 = new Thread(new Runnable() {

            @Override
            public void run() {
                counter.increment1();
            }
        });

        Thread t2 = new Thread(new Runnable() {

            @Override
            public void run() {
                counter.increment2();
            }
        });

        t1.start();
        t2.start();

        t1.join();
        t2.join();

        System.out.println("Value: " + counter.getField());
        Assert.assertEquals(counter.getField(), 2);
    }

    public static void main(String[] args) throws InterruptedException {
        new Deadlock().test();
    }

}
