package jBench.programs.buffer;

import java.util.LinkedList;

/**
 * 
 * @author MTMT
 * 
 */
public class Buffer<T> {

  private final int capacity;

  private LinkedList<T> buffer = new LinkedList<T>();

  public Buffer(int maxCapacity) {
    this.capacity = maxCapacity;
  }

  private T getImpl() throws InterruptedException {
    while (buffer.size() == 0)
      wait();

    notifyAll();

    return buffer.removeFirst(); // original
  }

  public T get() throws InterruptedException {
    synchronized (this) { // original
      return getImpl();
    }
  }

  private void putImpl(T item) throws InterruptedException {
    while (buffer.size() == capacity)
      wait();

    buffer.addLast(item); // original

    notifyAll(); // original
  }

  public void put(T item) throws InterruptedException {
    synchronized (this) { // original
      putImpl(item);
    }
  }

  public int size() {
    synchronized (this) {
      return buffer.size(); // original
    }
  }

}