package jBench.programs.buffer;

import java.util.LinkedList;
import java.util.List;

/**
 * 
 * @author MTMT
 * 
 */
public class Consumer<T> implements Runnable {

  private final Buffer<T> buffer;

  private final List<T> consumedItems = new LinkedList<T>();

  private int numOfItemsToConsume;

  public Consumer(Buffer<T> buffer, int numOfItemsToConsume) {
    this.buffer = buffer;
    this.numOfItemsToConsume = numOfItemsToConsume;
  }

  public void run() {
    try {
      while (numOfItemsToConsume > 0) {
        T item = buffer.get();
        consumeItem(item);
        numOfItemsToConsume--; // original
      }
    } catch (Exception ex) {
    }
  }

  public List<T> getConsumedItems() {
    return consumedItems;
  }

  private void consumeItem(T item) {
    consumedItems.add(item);
  }

}