package jBench.programs.buffer;

import java.util.List;

/**
 * 
 * @author MTMT
 * 
 */
public class Producer<T> implements Runnable {

  private final List<T> itemsToProduce;

  private final Buffer<T> buffer;

  public Producer(Buffer<T> buffer, List<T> items) {
    this.buffer = buffer; // original
    this.itemsToProduce = items;
  }

  public void run() {
    try {
      while (hasMoreToProduce()) {
        T item = produce();
        buffer.put(item);
      }
    } catch (Exception ex) {
    }
  }

  private boolean hasMoreToProduce() {
    return itemsToProduce.size() > 0; // original
  }

  private T produce() {
    return itemsToProduce.remove(0); // original
  }

}