package jBench.programs.norollback;

import java.util.Map;

public class Accounts {
  // ticket id -> true (sold) / false (free)
  static Map<Integer, Boolean> tickets;

  // account id -> balance amount
  static Map<Integer, Integer> accounts;

  final static int SUM = 10;
  final static int BAL = 20;

  public static boolean book(int ticketId, int bankId) {
    // reservation
    synchronized (NoRollbackTest.class) {
      Integer b = accounts.get(bankId);
      // precheck
      if (!tickets.get(ticketId) && b != null && b >= SUM) {
        tickets.put(ticketId, true);
      } else {
        return false;
      }
    }

    // withdrawal
    synchronized (NoRollbackTest.class) {
      Integer b = accounts.get(bankId);
      if (b != null && b >= SUM) {
        accounts.put(bankId, b - SUM);
      } else {// rollback
        // System.out.println("Rollback ticket " + ticketId);
        tickets.put(ticketId, false); // comment for bug
        return false;
      }
    }
    return true;
  }

  public static synchronized int numOfSoldTickets() {
    int tsold = 0;
    for (int i = 0; i < tickets.size(); i++) {
      if (Accounts.tickets.get(i))
        tsold++;
    }
    return tsold;
  }

  public static synchronized int overalBalance() {
    int balance = 0;
    for (int i = 0; i < accounts.size(); i++) {
      balance += Accounts.accounts.get(i);
    }
    return balance;
  }

  // public static boolean book2(int ticketId, int bankId) {
  // synchronized (NoRollbackTest.class) {
  // Integer b = accounts.get(bankId);
  // if (b != null && b >= SUM) {
  // accounts.put(bankId, b - SUM);
  // } else {
  // return false;
  // }
  // }
  // synchronized (NoRollbackTest.class) {
  // if (!tickets.get(ticketId)) {
  // tickets.put(ticketId, true);
  // } else {// rollback
  // System.out.println("Rollback account " + bankId);
  // Integer b = accounts.get(bankId);
  // accounts.put(bankId, b + SUM);
  // return false;
  // }
  // }
  // return true;
  // }

}
